<template>
    <div class="">
            <button v-if="authorize('ajoute-client')"  @click="showModalOnCreate"  class="add-button-mobile ml-4 btn btn-xs btn-secondary text-xs"> 
                           <i class="fas fa-plus-circle right "></i>  
            </button>
            <page-header title="Clients">
              <div slot="nav">
                <div v-if="authorize('exporte-client')" class=" drowpdown mr-3">
                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-plus-circle mr-3"></i>Exporter vers
                    </button>
                    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                          <a :href="excelUrl"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
                          <a href="javascript:;" class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-pdf t-plus-1 text-danger fa-fw fa-lg "></i> PDF</a>
                    </div>
                    </div>
              </div>
            </page-header>
            <div class="col-md-12">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <h3 class="card-title mb-0 hidden-xs">
                        <button v-if="authorize('ajoute-client')" @click="showModalOnCreate"  class="ml-4 btn btn-xs btn-secondary text-xs"> 
                           <i class="fas fa-plus-circle right "></i>  Nouveau client
                        </button>
                    </h3>

                    <div class="card-tools d-flex">
                         <filter-bar ref="filterBar"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive  p-0 position-relative " v-show="!NoDataForSearch && !NoDataAtAll" >
                    <vuetable :css="table" ref="vuetable" api-url="api/clients" :fields="columns" 
                           pagination-path=""
                           :per-page="15"
                           :http-options="httpOptions"
                           @vuetable:loading="onLoading" 
                           @vuetable:loaded="onLoadingDone"
                           :append-params="moreParams" 
                           @vuetable:pagination-data="onPaginationData">
                         <template slot="email" slot-scope="props">   
                            <div class="custom-actions">
                                <span class="nr text-upper"><i class="fas fa-envelope mr-1"></i>{{props.rowData.email}}</span>
                            </div>
                            </template>
                            <template slot="actions" slot-scope="props">   
                            <div class="custom-actions">
                                <button v-if="authorize('modifie-client')" title="Modifier le client" class="btn btn-xs btn-secondary"
                                @click="showModalOnEdit(props.rowData)">
                                <i class="fas fa-edit"></i>
                                </button>
                                 <a v-if="authorize('exporte-client')" :title=" props.rowData.hasFile ?'Télécharger la pièce d\'identité' : 'Aucune pièce d\'identité disponible'"  :href=" props.rowData.hasFile ? '/clients/'+props.rowData.id+'/download' :'javascript:void(0)' " :class="[props.rowData.hasFile ?'btn btn-xs btn-default' : 'btn btn-xs btn-default disabled']">
                                  <i class="fas fa-download"></i>
                                </a> 
                                <button v-if="authorize('supprime-client')" title="supprimer le client" class="btn btn-xs btn-danger"
                                @click="remove(props.rowData.id)">
                                <i class="fas fa-trash"></i>
                                </button>
                            </div>
                            </template>
                    </vuetable>
              </div>
              <pa ref="pagination" :is-loading="isLoading"  :pager="[15,25,50,100]" @vuetable-pagination:change-page="onChangePage" v-show="!NoDataForSearch && !NoDataAtAll"   ></pa>
              <!-- /.card-body -->
               </div>
               <no-data-in-search v-show="pageInit" :search="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search>
              <!-- Modal dbt -->
              <b-modal @hidden="reset" size="lg"  ref="inputModal" id="my-modal" :title="ModalTitle"  :hide-footer="true">
                <form class="" method="POST"  @submit.prevent="onSubmit()"
                               @reset.prevent="reset()" 
                                @keydown="form.errors.clear($event.target.name)" 
                               @change="form.errors.clear($event.target.name)">
                        <div class="form-group ">
                           <div class="row">
                               <div class="col">
                                    <label class="">Nom du  client</label>
                                    <input :class="['form-control form-control-sm', form.errors.has('nom')? ' is-invalid' : '']" name="nom" v-model="form.nom" type="text"/>
                                     <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom')" v-text="form.errors.get('nom')"></span>
                               </div>
                               <div class="col">
                                   <label class="">Prénom du client</label>
                                   <input :class="['form-control form-control-sm', form.errors.has('prenom')? ' is-invalid' : '']" name="prenom" v-model="form.prenom" type="text"/>
                                   <span class="m-form__help m--font-danger"  v-if="form.errors.has('prenom')" v-text="form.errors.get('prenom')"></span>
                               </div>
                           </div>
                        </div>
                        <div class="form-group ">
                           <div class="row">
                                 <div class="col">
                                         <label class="">Date de naissance</label>
                                          <vc-date-picker :maxDate="maxDate" @input="datepickerEvent($event,'date_naissance')" is-expanded  single-date-="single" name="date_naissance" :class="['', form.errors.has('date_naissance')? ' is-invalid' : '']" v-model="date_naissance" type="text"></vc-date-picker>
                                         <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_naissance')" v-text="form.errors.get('date_naissance')"></span>
                                 </div>
                                 <div class="col">
                                    <label class="">Adresse</label>
                                        <input :class="['form-control form-control-sm', form.errors.has('adresse')? ' is-invalid' : '']" id="datetimepicker6" name="adresse" v-model="form.adresse"/>
                                         <span class="m-form__help m--font-danger"  v-if="form.errors.has('adresse')" v-text="form.errors.get('adresse')"></span>
                                 </div>
                           </div>
                        </div>
                        <div class="form-group ">
                            <div class="row">
                               <div class="col">
                                    <label class="">Téléphone</label>
                                    <input :class="['form-control form-control-sm', form.errors.has('telephone1')? ' is-invalid' : '']" name="telephone1" v-model="form.telephone1" type="text"/>
                                     <span class="m-form__help m--font-danger"  v-if="form.errors.has('telephone1')" v-text="form.errors.get('telephone1')"></span>
                               </div>
                               <div class="col">
                                   <label class="">E-mail</label>
                                   <input :class="['form-control form-control-sm', form.errors.has('email')? ' is-invalid' : '']" name="email" v-model="form.email" type="text"/>
                                   <span class="m-form__help m--font-danger"  v-if="form.errors.has('email')" v-text="form.errors.get('email')"></span>
                               </div>
                           </div>
                        </div>
                        <div class="form-group ">
                            <div class="row">

                               <div class="col-auto">
                                    <label class="">Type de pièce</label>
                                    <select :class="['form-control form-control-sm', form.errors.has('type_piece_identite')? ' is-invalid' : '']" name="type_piece_identite" v-model="form.type_piece_identite" type="text">
                                          <option value="">Choix du type de pièce</option>
                                          <option value="CNI">CNI</option>
                                          <option value="Passeport">Passeport</option>
                                          <option value="Recipissé CNI">Recipissé CNI</option>
                                          <option value="Permis de conduire">Permis de conduire</option>
                                          <option value="Autres">Autres</option>

                                    </select>
                                     <span class="m-form__help m--font-danger"  v-if="form.errors.has('type_piece_identite')" v-text="form.errors.get('type_piece_identite')"></span>
                               </div>
                               <div class="col">
                                   <label class="">Fichier de la copie de la pièce</label>
                                    <document-input @file-has-changed="onDocumentInputChanged" :placeholder="form.piece_identite!='' ? form.piece_identite : 'Choissisez votre fichier'"></document-input>
                                   <span class="m-form__help m--font-danger"  v-if="form.errors.has('piece_identite')" v-text="form.errors.get('piece_identite')"></span>
                               </div>
                           </div>
                        </div>

                      <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
														<button type="submit" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
					  </div>
               </form>
            </b-modal>
            <!-- Modal fin -->
</div>
    </div>
</template>

<script>

   import  Vuetable from "vuetable-2/src/components/Vuetable";
   import pa from './../../components/pagination/Pagination'
   import Form from "./../../classes/Form"
   import Master from "./../Master.vue";
   import DocumentInput from "./../../components/DocumentInput"


    export default {
        mixins: [Master],
        data(){
            return{
                modeEdit:false,
                ftime:true,
                hasData:false,
                date_naissance:'',
                maxDate:"",
                form : new Form({
                    nom:'',
                    prenom:"",
                    piece_identite:"",
                    type_piece_identite:"",
                    date_naissance:"",
                    adresse:"",
                    telephone1:"",
                    email:""

                }),
                moreParams:{filter:""},
                isLoading:false,
                columns : [
                {
                    name: 'nom',
                    title: "Nom(s)"
                },
                {
                    name: 'prenom',
                    title: "Prénom(s)"
                },
                {
                name:"date_naissance",
                title: "Date de naissance",
                 titleClass: 'center aligned',
                dataClass: 'center aligned',
                callback:'toDateFormat'
                },
                ,
                {
                name: '__slot:email',   // <----
                title: 'E-mail',
                },
                {
                    name: 'telephone1',
                    title: "Téléphone"
                },
                {
                    name: 'adresse',
                    title: "Adresse"
                },
            
                {
                name: '__slot:actions',   // <----
                title: 'Actions',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                }
                
                ],
                  table: {
                    tableWrapper: '',
                    tableHeaderClass: 'mb-0',
                    tableBodyClass: 'mb-0',
                    tableClass: 'table table-striped table-hover',
                    ascendingIcon: 'fa fa-chevron-up',
                    descendingIcon: 'fa fa-chevron-down',
                    ascendingClass: 'sorted-asc',
                    descendingClass: 'sorted-desc',
                    sortableIcon: 'fa fa-sort',
                    detailRowClass: 'vuetable-detail-row',
                    handleIcon: 'fa fa-bars text-secondary',
                    renderIcon(classes, options) {
                      return `<i class="${classes.join(' ')}"></span>`
                    }
                  }
            }
        },
        created()
        {
          this.modeEdit = false
          if(!this.authorize('any',['modifie-client','exporte-client','supprime-client']))
          {
            this.columns=this.columns.filter((column) => {
                 return column.name !="__slot:actions"
            })
          }
 
        },
        mounted() {
                this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
                this.$events.$on('filter-reset', e => this.onFilterReset())
        },
        computed:
        {
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'un client"  : " Ajout d'un client"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            shouldGoToFirstPage()
            {
              if(this.$refs.vuetable)
              {
                return (this.$refs.vuetable.tableData.length) - 1 == 0
              } 
              else
              {
                return false
              }
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            },
            excelUrl()
           {
             return '/clients/export?format=excel&filter='+this.moreParams.filter
           },
           pdfUrl()
           {
             return '/depenses/export?format=pdf&q='+this.searchTxt
           },
        },
        methods: 
        {
                datepickerEvent(event,name)
                {
                  console.log(event)
                    if(name=="date_naissance")
                    {
                      
                        this.form.date_naissance = moment(event).format('YYYY-MM-DD')
                        this.form.checkError(name)

                    }
                },
            onDocumentInputChanged(name)
            {
               if(isDefined(name))
               {
                   this.form.piece_identite = name 
                   
               }
               if(this.form.errors.has('piece_identite'))
                  this.form.errors.clear('piece_identite')

              this.$forceUpdate()
            },
            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            onPaginationData (paginationData) 
            {
              if(this.pageInit==false)
                 this.pageInit =true
              else
              {
                
              }
              this.hasData = paginationData.data.length > 0
              this.$refs.pagination.setPaginationData(paginationData)
            },
            onChangePage (page) 
            {
               
               this.$refs.vuetable.changePage(page)
            },
            onLoading() 
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                }
                this.ftime = false
            },
            onLoadingDone() 
            {
               this.labels()
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },
            onAction (action, data, index) {
            console.log('slot) action: ' + action, data, index)
            },
            onFilterSet (filterText) {
                this.moreParams.filter = filterText
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterReset () {
                this.moreParams.filter = ""
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            //Retire un role de la BDD
             remove(e)
             {
                 
                  
                  //On demande la confirmation de la suppression
                    alertConfirm("Voulez-vous supprimer ce client ?","Suppréssion d'un client")
                    .then(result => {
                        //On réinitialise le chargement
                        this.isLoading = true
                        if(result)
                        {
                           axios.delete("api/clients/"+e).then((response) => 
                            { 
                             // on rafraichit la page de donnée actuelle
                              !this.shouldGoToFirstPage ? this.$refs.vuetable.reload() : this.$refs.vuetable.refresh()
                              //on notifie l'effectivité de la suppréssion
                              flash('Suppresion réussie')
                              //On réinitialise le chargement
                              this.isLoading = false

                            },
                            (error) =>
                            {
                              this.isLoading = false
                            });
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });
             },
             //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Si on edite pas
                if(!this.modeEdit)
                  //on ajoute un nouveau
                   this.add()
                else 
                //alors on actualise
                  this.update()
             },
            //Ajoute un role dans la BDD
            add()
            {
                //Requête ajax
                this.form.post("api/clients").then((value) => 
                {  
                  this.reset()
                  // on ramène les données sur la page 1
                  this.$refs.vuetable.refresh()
                  flash("<span>Enregistré <strong>avec succès</strong></span>")

                },
                (error) =>
                {
                  this.isLoading = false
                });                  
            },
            //Actualise  un role dans la BDD
            update()
            {
              
                //Requête ajax
                this.form.patch("api/clients/"+this.form.id).then((value) => 
                {
                  
                   // on rafraichit la page des données actuelle
                  this.$refs.vuetable.reload()
                  //On remet à zero notre formulaire
                  this.reset()
                  //on affiche le message 
                  flash("<span>Modifié <strong>avec succès</strong></span>")
                  

                },
                (error) =>
                {
                  this.isLoading = false
                  //on affiche le message 
                  flash("<span>Ajout <strong>impossible</strong></span>","danger")
                });                  
            },
            //On affiche le modal pour la création
            showModalOnCreate()
            {
    
                this.modeEdit = false
                this.reset()
                this.$refs['inputModal'].show()
              
            },
            //On affiche le modal pour l'édition
            showModalOnEdit(entity)
            {
               
                this.reset()
                this.modeEdit = true

                this.form.libelle = entity.libelle
                this.form.id=entity.id
                this.form.prenom=entity.prenom
                this.form.nom=entity.nom
                this.maxDate = moment().subtract(18,'years').format()
                this.form.date_naissance = entity.date_naissance
                this.date_naissance=moment(entity.date_naissance).toDate()
                this.form.piece_identite=entity.piece_identite
                this.form.type_piece_identite=entity.type_piece_identite
                this.form.adresse=entity.adresse
                this.form.email=entity.email
                this.form.telephone1=entity.telephone1

                this.$refs['inputModal'].show()
             },
              //Initialisation du formulaire
              reset()
             {
                this.form.prenom=""
                this.form.piece_identite=""
                this.form.type_piece_identite=""
                this.form.adresse=""
                this.form.date_naissance=""
                this.date_naissance=""
                this.form.email=""
                this.form.telephone1=""
                this.maxDate = moment().subtract(18,'years').format()
                this.form.errors.clearAll()
                this.$refs['inputModal'].hide()
                this.modeEdit = false
                this.isLoading = false
                if(this.moreParams.hasOwnProperty('filter'))
                this.moreParams.filter=""
             },
              toDateFormat(value) 
            {
              if(value=="" || value==null || value==undefined)
              return ""
              else
              return  toDateFormat(value,"DD-MM-YYYY")
            },
             download(client)
             {
              axios({
                url: "/api/clients/"+client.id+"/download",
                method: 'GET',
                responseType: 'blob', // important
                }).then((response) => 
                {
                    const url = window.URL.createObjectURL(new Blob([response.data]));
                    const link = document.createElement('a');
                    link.href = url;
                    link.setAttribute('download','permis-conduire-'+client.type_piece_identite);
                    document.body.appendChild(link);
                    link.click();
                })  
             }
              
        },
        components:
        {

            Vuetable,
            pa,
            DocumentInput
        }
    }
</script>